#!/bin/bash

#Allegra print server helper script. Starts, stops the server.

usage () {
  echo "Usage: $0 COMMAND"
  echo
  echo "Commands:"
  echo "    start:      Starts Allegra print server"
  echo "    stop:       Stops Allegra print server"
  echo "    test:       Tests if the service is running. If the response is a JSON, then the service is running!"
  echo
  echo "The print server  should be available under: https://allegra-software.com/allegra-print-server/"
  exit 1
}

command=$1

HTTP_PORT=8090
CTX_PATH="/allegra-print-server"

run_start() {
        echo "Starting Allegra Print server"
        nohup ./server  -h $HTTP_PORT -p $CTX_PATH --no-sandbox -m 500mb &
        echo "Allegra print server has been started"
}

run_stop() {
        echo "Stopping Allegra print server"
        echo "STOP"     
        PROCESS=`ps -axf | grep allegra-print-server | tail -1 | cut -f1 -d " "`
        echo "The PID is: $PROCESS"
        kill -9 $PROCESS
        echo "Allegra print server has been stopped"
}

run_test() {
        echo "Testing the service"
        curl --location --request POST 'http://localhost:8090/allegra-print-server' --header 'Content-Type: application/json'
}

case "$command" in
  'start')
          run_start
      exit 0
      ;;
  'stop')
          run_stop
      exit 0
      ;;
  'test')
          run_test
      exit 0
      ;;
  *)
      usage
      ;;
esac


